@inject Backend back
@inject Waiter wagter
@inject Observatory obz
@implements IDisposable

<div class="custom-scroller" style="height: 100%; width: 100%;">
<div class="card shadow-sm" style="overflow-y: auto; height: 100%; padding: 24px 12px; width: 100%;">
@if (StatusData.response_detail == null) {
    <p style="text-align: center;">Loading responses...</p>
}else{
    <div class="d-flex" style="flex-wrap: wrap; height: fit-content;">
        @foreach(ResponsePlay resp in StatusData.response_detail.responses){
            <div style="margin-right: 8px; margin-bottom: 8px; height: fit-content;"
                onmouseleave="document.getElementById('btn-'+'@resp.GetElID()').style['display']='none'" 
                onmouseover="document.getElementById('btn-'+'@resp.GetElID()').style['display']='block'">
                @for (int j = 0; j < resp.cards.Length; j++){
                    <div class="card cah-card" style="z-index: @j; margin-top: @getRespTop(j); margin-left: @getRespLeft(j); background-color: @getRespBGCol(resp.id);">
                        <div class="d-flex" style="flex-direction: column; height: 100%;">
                            <div>@resp.cards[j]</div>
                            <div style="flex-grow: 1"></div>
                            @if(j==resp.cards.Length-1){
                                <div style="display: none; margin: auto;" id="btn-@resp.GetElID()">
                                    @if (StatusData.in_game_data.card_czar==back.GetPlayerNick() && StatusData.winning_player == null){
                                        <SpinButton OnClickCallback="()=>OnCardClick(resp.id)" SpinningKey="awaitingWinnerPicked">Select Winner</SpinButton>
                                    }
                                </div>
                                @if (StatusData.winning_player != null && StatusData.winning_response_id==resp.id){
                                    <div style="width: 100%; text-align: center; font-size: .8em; border: 2px solid white;">Winner: @StatusData.winning_player</div>
                                }
                            }
                        </div>
                    </div>
                }
            </div>
        }
    </div>
}
</div>
</div>


@code {

    [Parameter]
    public StatusData StatusData {get;set;}

    [Parameter]
    public bool LargeScreen {get;set;}

    protected override void OnInitialized(){
        obz.Register<WinnerPickedMessage>("WINNER_PICKED", (WinnerPickedMessage _)=>{
            wagter.SetState("awaitingWinnerPicked", false); // other relevant stuff passed in through StatusData
        }, "ResponsesFaceUpComponent");
    }

    private string getRespBGCol(long respId){
        if (StatusData.winning_response_id == respId)
            return "gold";
        else
            return "white";
    }

    private string getRespTop(int i){
        var top = LargeScreen ? 60 : 30;
        return $"{i*-top}px";
    }
    private string getRespLeft(int i){
        var left = LargeScreen ? 240 : 120;
        return $"{i*-left}";
    }

    private void OnCardClick(long respId){
        back.SendMessage(new PickWinnerMessage(respId));
        wagter.SetState("awaitingWinnerPicked", true);
    }

    public void Dispose(){
        obz.Deregister("ResponsesFaceUpComponent");
    }

}
